<template>
<div class="date-selector">
  <p class="date-selector__selector-label">{{ props.selectorLabel }}</p>
  <q-field
    class="cursor-pointer"
    filled
    :disable="isFetching"
    :error="!isDateRangeValid"
    :error-message="errorMessage"
  >
    <template v-slot:default>

      <div
        class="self-center q-pa-sm full-width no-outline"
        tabindex="0"
      >
        {{ getNormalizedName(UIdataModel.pickedMonth, 'month_full_name') }} {{ UIdataModel.pickedYear }}
      </div>
      <q-menu
        :max-width="`${0.85 * resize.width}px`"
        anchor="bottom middle"
        self="top middle"
        @hide="updateModelValue()"
      >
        <div class="date-selector__picker q-px-lg">
          <div class="date-selector__picker__year-picker row justify-evenly items-center q-my-sm">
            <q-btn
              class="date-selector__picker__year-picker__decrement-year-button"
              @click="changeYear('decrYear')"
              :disable="isYearChangeDisabled('decrYear') || isFetching"
              dense
              flat
              icon="navigate_before"
              size="lg"
              round
            />
            <div class="date-selector__picker__year-picker__picked-year">
              {{UIdataModel.pickedYear}}
            </div>
            <q-btn
              class="date-selector__picker__year-picker__increment-year-button"
              @click="changeYear('incrYear')"
              :disable="isYearChangeDisabled('incrYear') || isFetching"
              dense
              flat
              icon="navigate_next"
              size="lg"
              round
            />
          </div>
          <div class="date-selector__picker__month-picker row">
            <q-btn
              v-for="month in monthsList"
              :key="month"
              class="date-selector__picker__month-picker__pick-month-button col-4 text-weight-regular"
              :label="month.label"
              :disable="isMonthDisabled(month.value) || isFetching"
              :flat="!isMonthSelected(month.value)"
              :color="isMonthSelected(month.value) ? 'primary': 'standart'"
              :text-color="isMonthSelected(month.value) ? 'white': 'black'"
              @click="selectMonth(month.value)"
              size="md"
              align="center"
              padding="xs"
              unelevated
            />
          </div>
        </div>
      </q-menu>
    </template>
    <template v-slot:append>
      <q-icon name="event" color="primary" class="cursor-pointer" />
    </template>
  </q-field>
  <q-resize-observer @resize="onResize" />
</div>
</template>

<script setup>
import { ref, computed, watchEffect } from 'vue'
import getNormalizedName from 'src/composables/get_normalized_name';

const props = defineProps({
  startPossibleYearOfPeriod: { type: Number, required: true },
  isDateRangeValid: { type: Boolean, required: true },
  selectorLabel: { type: String, required: true },
  modelValue: { type: Object, required: true },
  isFetching: { type: Boolean, required: true },
  errorMessage: { type: String, required: true },
});

const emit = defineEmits(['update:modelValue']);

const localModel = computed({
  get: () => props?.modelValue,
  set: () => updateModelValue()
});

let UIdataModel;

const updateModelValue = () => {
  emit("update:modelValue", UIdataModel.value)
};

const errorMessage = computed(() => props.errorMessage);

const currentYear = new Date().getFullYear();

const monthsList = [
  { label: 'Ene', value: 0 },
  { label: 'Feb', value: 1 },
  { label: 'Mar', value: 2 },
  { label: 'Abr', value: 3 },
  { label: 'May', value: 4 },
  { label: 'Jun', value: 5 },
  { label: 'Jul', value: 6 },
  { label: 'Ago', value: 7 },
  { label: 'Sep', value: 8 },
  { label: 'Oct', value: 9 },
  { label: 'Nov', value: 10 },
  { label: 'Dic', value: 11 },
];

const resize = ref(0);

const changeYear = (arg) => {
  if (arg === 'decrYear' && UIdataModel.value.pickedYear > props.startPossibleYearOfPeriod) {
    UIdataModel.value.pickedYear -= 1;
  } else if (arg === 'incrYear' && UIdataModel.value.pickedYear < currentYear) {
    UIdataModel.value.pickedYear += 1;
    if (UIdataModel.value.pickedYear === currentYear) {
      UIdataModel.value.pickedMonth = new Date().getMonth() - 1;
    }
  }
};

const isYearChangeDisabled = (action) => {
  if (action === 'decrYear') {
    return UIdataModel.value.pickedYear <= props.startPossibleYearOfPeriod;
  } else if (action === 'incrYear') {
    return UIdataModel.value.pickedYear >= currentYear;
  }
};

const selectMonth = (val) => {
  UIdataModel.value.pickedMonth = val;
};

const isMonthSelected = (val) => {
  return val === UIdataModel.value.pickedMonth;
};

const isMonthDisabled = (val) => {
  return (UIdataModel.value.pickedYear > currentYear || (UIdataModel.value.pickedYear === currentYear && val >= new Date().getMonth()));
};

const onResize = function (size) {
  resize.value = size;
};

watchEffect(() => {
  UIdataModel = ref(Object.assign({}, localModel.value));
});

</script>

<style lang="scss">
@use './date-picker-component-stylesheet.scss';
</style>
